<?php

function pw_boss_search_form() {
	$user_query = null;
	if (isset($_GET['q'])) {
		$user_query = urldecode($_GET['q']);
	}
?>
<h2 class="entry-title"><?php pw_boss_title(); ?></h2>
<div class="search-form">
	<form action="" method="get">
		<input type="text" name="q" id="search-input" value="<?php print $user_query; ?>" /> 
		<input type="submit" value="<?php pw_boss_button(); ?>" />
	</form>
</div>
<?php
}

function pw_boss_search_results() {
	global $pw_yahoo_boss;
	
	$search = new pw_yahoo_boss_results($pw_yahoo_boss);
	
	if(!empty($_GET['q'])) {
?>
	<hr />
	<div class="result-info">
<?php
	print ($search->start + 1) . ' - ' . (($search->start + 1) + $search->count - 1);
	print ' of ' . $search->totalhits . ' for <b>' . urldecode($search->query) . '</b>';
	print "</div>";
	
	foreach ($search->results as $key => $result) {
?>
	<div class="result" id="result_<?php print ($key + 1); ?>">
		<h3 class="result-title"><a href="<?php print $result['clickurl']; ?>"><?php print $result['title']; ?></a></h3>
		<div class="result-abstract"><?php print $result['abstract']; ?></div>
		<div class="result-meta">
			<span class="result-url" title="<?php print $result['url']; ?>"><?php print $result['dispurl']; ?></span> - 
			<span class="result-size"><?php print $result['size_f']; ?></span>
		</div>
	</div>
<?php }
	// Write the Prev and Next page links
?>
	<hr />
	<div>
<?php
	if ($search->page > 1) {
		echo '<span class="result-page"><a href="?q=' . $search->query . '&amp;page=' . ($search->page - 1) . '">&lt; Prev</a></span> ';
	}
	
	$start = $search->page - (($search->page <= 5) ? ($search->results_per_page - $search->page) : 10);
	if ($start < 1) 
		$start = 1;
	
	$end = $search->page + (($search->page <= 5) ? ($search->results_per_page - $search->page) : 5);
	if ($end > ($search->totalhits / $search->results_per_page)) 
		$end = floor($search->totalhits / $search->results_per_page) + 1;
	
	for ($i = $start; $i <= $end; $i++) {
		if ($i == $search->page) {
			print '<span class="result-page-current">' . $i . "</span> ";
		} else {
			print '<span class="result-page"><a href="?q=' . $search->query . '&amp;page=' . $i . '">'.$i.'</a></span> ';
		}
	}
	if ($search->result_counter - 1 < $search->totalhits) {
		echo '<span class="result-page"><a href="?q=' . $search->query . '&amp;page=' . ($search->page + 1) . '">Next &gt;</a></span>';
	}
?>
	</div>
	
<?php
	}
}

function pw_boss_title() {
	$boss_title = 'Custom Search with Yahoo BOSS';
	print apply_filters('pw_boss_title', $boss_title);
}

function pw_boss_button() {
	$button_text = 'Search';
	print apply_filters('pw_boss_button', $button_text);
}
?>